"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MidwayApplicationManager = void 0;
const interface_1 = require("../interface");
const decorator_1 = require("../decorator");
let MidwayApplicationManager = class MidwayApplicationManager {
    constructor() {
        this.globalFrameworkMap = new Map();
    }
    addFramework(frameworkNameOrNamespace, framework) {
        this.globalFrameworkMap.set(frameworkNameOrNamespace, framework);
    }
    hasFramework(frameworkNameOrNamespace) {
        return this.globalFrameworkMap.has(frameworkNameOrNamespace);
    }
    getFramework(frameworkNameOrNamespace) {
        if (this.globalFrameworkMap.has(frameworkNameOrNamespace)) {
            return this.globalFrameworkMap.get(frameworkNameOrNamespace);
        }
    }
    getApplication(frameworkNameOrNamespace) {
        if (this.globalFrameworkMap.has(frameworkNameOrNamespace)) {
            return this.globalFrameworkMap
                .get(frameworkNameOrNamespace)
                .getApplication();
        }
    }
    getApplications(frameworkNameOrNamespace) {
        if (!frameworkNameOrNamespace) {
            return Array.from(this.globalFrameworkMap.values()).map(framework => {
                return framework.getApplication();
            });
        }
        else {
            return frameworkNameOrNamespace
                .map(namespace => {
                return this.getApplication(namespace);
            })
                .filter(app => {
                return !!app;
            });
        }
    }
};
exports.MidwayApplicationManager = MidwayApplicationManager;
exports.MidwayApplicationManager = MidwayApplicationManager = __decorate([
    (0, decorator_1.Provide)(),
    (0, decorator_1.Scope)(interface_1.ScopeEnum.Singleton)
], MidwayApplicationManager);
//# sourceMappingURL=applicationManager.js.map