import { IFileDetector, IMidwayGlobalContainer } from '../interface';
export declare abstract class AbstractFileDetector<T> implements IFileDetector {
    options: T;
    constructor(options?: T);
    abstract run(container: IMidwayGlobalContainer, namespace: string): Promise<void>;
    abstract runSync(container: IMidwayGlobalContainer, namespace: string): void;
}
/**
 * CommonJS module loader
 */
export declare class CommonJSFileDetector extends AbstractFileDetector<{
    loadDir?: string | string[];
    pattern?: string | string[];
    ignore?: string | string[];
    conflictCheck?: boolean;
}> {
    private duplicateModuleCheckSet;
    run(container: IMidwayGlobalContainer, namespace: string): Promise<void>;
    loadSync(container: IMidwayGlobalContainer, namespace: string): void;
    loadAsync(container: IMidwayGlobalContainer, namespace: string): Promise<void>;
    getType(): 'commonjs' | 'module';
    runSync(container: IMidwayGlobalContainer, namespace: string): void;
}
/**
 * ES module loader
 */
export declare class ESModuleFileDetector extends CommonJSFileDetector {
    getType(): 'commonjs' | 'module';
}
export declare class CustomModuleDetector extends AbstractFileDetector<{
    modules?: any[];
    namespace?: string;
}> {
    run(container: IMidwayGlobalContainer): Promise<void>;
    runSync(container: IMidwayGlobalContainer, namespace: string): void;
}
//# sourceMappingURL=fileDetector.d.ts.map