import { ClassType, IMidwayContainer, IMidwayGlobalContainer, ObjectIdentifier } from '../interface';
/**
 * 解析工厂
 */
export declare class ManagedResolverFactory {
    private creating;
    singletonCache: Map<ObjectIdentifier, any>;
    context: IMidwayGlobalContainer;
    constructor(context: IMidwayGlobalContainer);
    /**
     * 同步创建对象
     * @param identifier
     * @param args
     * @param currentContext
     */
    create<T = any>(identifier: ClassType<T> | string, args: any[], currentContext: IMidwayContainer): T;
    createAsync<T = any>(identifier: ClassType<T> | string, args: any[], currentContext: IMidwayContainer): Promise<T>;
    destroyCache(): Promise<void>;
    private getObjectEventTarget;
    private checkSingletonInvokeRequest;
    private setInstanceScope;
    private createInstance;
    private initializeInstance;
    private initializeInstanceAsync;
    private storeInstanceScope;
    private getObjectDefinition;
    private getCurrentMatchedContext;
    private translateIdentifiers;
}
//# sourceMappingURL=managedResolverFactory.d.ts.map