import { ClassType, IMidwayGlobalContainer, IMidwayRequestContainer, ObjectIdentifier, ScopeEnum } from '../interface';
import { ObjectDefinitionRegistry } from './definitionRegistry';
export declare class MidwayRequestContainer implements IMidwayRequestContainer {
    protected readonly ctx: any;
    protected readonly applicationContext: IMidwayGlobalContainer;
    parent: IMidwayGlobalContainer;
    registry: ObjectDefinitionRegistry;
    private attrMap;
    constructor(ctx: any, applicationContext: IMidwayGlobalContainer);
    get<T = any>(identifier: ClassType<T> | string, args?: any): T;
    getAsync<T = any>(identifier: ClassType<T> | string, args?: any): Promise<T>;
    getContext(): any;
    hasDefinition(identifier: ObjectIdentifier): boolean;
    getDefinition(identifier: ObjectIdentifier): import("../interface").IObjectDefinition;
    registerObject(identifier: string, obj: any): void;
    hasObject(identifier: ObjectIdentifier): boolean;
    getObject<T>(identifier: ObjectIdentifier): T;
    setAttr(key: string, value: any): void;
    getAttr<T>(key: string): T;
    getIdentifier(identifier: ClassType | string): string;
    getInstanceScope(instance: any): ScopeEnum | undefined;
    hasNamespace(namespace: string): boolean;
}
//# sourceMappingURL=requestContainer.d.ts.map