"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Match = exports.Catch = void 0;
const constant_1 = require("../constant");
const provide_1 = require("./provide");
const interface_1 = require("../../interface");
const metadataManager_1 = require("../metadataManager");
const scope_1 = require("./scope");
function Catch(catchTarget, options = {}) {
    return function (target) {
        const catchTargets = catchTarget ? [].concat(catchTarget) : undefined;
        metadataManager_1.MetadataManager.defineMetadata(constant_1.CATCH_KEY, {
            catchTargets,
            catchOptions: options,
        }, target);
        (0, scope_1.Scope)(interface_1.ScopeEnum.Singleton)(target);
        (0, provide_1.Provide)()(target);
    };
}
exports.Catch = Catch;
function Match(matchPattern = true) {
    return function (target) {
        metadataManager_1.MetadataManager.defineMetadata(constant_1.MATCH_KEY, {
            matchPattern,
        }, target);
        (0, scope_1.Scope)(interface_1.ScopeEnum.Singleton)(target);
        (0, provide_1.Provide)()(target);
    };
}
exports.Match = Match;
//# sourceMappingURL=filter.js.map