/**
 * Framework decorator, use to define the framework module
 * @since 2.0.0
 */
export declare function Framework(): ClassDecorator;
/**
 * Plugin decorator, use to get egg plugin instance
 * @since 2.0.0
 */
export declare function Plugin(identifier?: string): PropertyDecorator;
/**
 * @deprecated Use @AllConfig() instead
 * @since 2.0.0
 */
export declare function Config(): PropertyDecorator;
/**
 * Config decorator, use to get config
 * @since 2.0.0
 */
export declare function Config(identifier: string): PropertyDecorator;
/**
 * Config decorator, use to get all config
 * @since 4.0.0
 */
export declare function AllConfig(): PropertyDecorator;
/**
 * @deprecated Use @MainApp() instead
 */
export declare function App(): PropertyDecorator;
/**
 * App decorator, use to get application instance, default is main application
 * If you want to get the application instance of other framework, you can use the namespace parameter to specify
 * @since 2.0.0
 */
export declare function App(namespace: string): PropertyDecorator;
/**
 * Get the main application instance
 * @since 4.0.0
 */
export declare function MainApp(): PropertyDecorator;
/**
 * Logger decorator, use to get logger instance
 * @since 2.0.0
 */
export declare function Logger(identifier?: string): PropertyDecorator;
/**
 * ApplicationContext decorator, use to get global IoC container instance
 * @since 3.0.0
 */
export declare function ApplicationContext(): PropertyDecorator;
//# sourceMappingURL=framework.d.ts.map