"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationContext = exports.Logger = exports.MainApp = exports.App = exports.AllConfig = exports.Config = exports.Plugin = exports.Framework = void 0;
const __1 = require("../");
const interface_1 = require("../../interface");
/**
 * Framework decorator, use to define the framework module
 * @since 2.0.0
 */
function Framework() {
    return (target) => {
        __1.DecoratorManager.saveModule(__1.FRAMEWORK_KEY, target);
        (0, __1.Scope)(interface_1.ScopeEnum.Singleton)(target);
        (0, __1.Provide)()(target);
    };
}
exports.Framework = Framework;
/**
 * Plugin decorator, use to get egg plugin instance
 * @since 2.0.0
 */
function Plugin(identifier) {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.PLUGIN_KEY, {
        identifier,
    });
}
exports.Plugin = Plugin;
function Config(identifier) {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.CONFIG_KEY, {
        identifier,
    });
}
exports.Config = Config;
/**
 * Config decorator, use to get all config
 * @since 4.0.0
 */
function AllConfig() {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.CONFIG_KEY, {
        identifier: __1.ALL_VALUE_KEY,
    });
}
exports.AllConfig = AllConfig;
function App(namespace) {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.APPLICATION_KEY, {
        type: namespace,
    });
}
exports.App = App;
/**
 * Get the main application instance
 * @since 4.0.0
 */
function MainApp() {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.MAIN_APPLICATION_KEY, {});
}
exports.MainApp = MainApp;
/**
 * Logger decorator, use to get logger instance
 * @since 2.0.0
 */
function Logger(identifier) {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.LOGGER_KEY, {
        identifier,
    });
}
exports.Logger = Logger;
/**
 * ApplicationContext decorator, use to get global IoC container instance
 * @since 3.0.0
 */
function ApplicationContext() {
    return __1.DecoratorManager.createCustomPropertyDecorator(__1.APPLICATION_CONTEXT_KEY, {});
}
exports.ApplicationContext = ApplicationContext;
//# sourceMappingURL=framework.js.map