"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Guard = exports.UseGuard = void 0;
const interface_1 = require("../../interface");
const constant_1 = require("../constant");
const provide_1 = require("./provide");
const metadataManager_1 = require("../metadataManager");
const scope_1 = require("./scope");
function UseGuard(guardOrArr) {
    return (target, propertyKey, descriptor) => {
        if (!Array.isArray(guardOrArr)) {
            guardOrArr = [guardOrArr];
        }
        metadataManager_1.MetadataManager.defineMetadata(constant_1.GUARD_KEY, guardOrArr, target, propertyKey);
    };
}
exports.UseGuard = UseGuard;
function Guard() {
    return target => {
        (0, provide_1.Provide)()(target);
        (0, scope_1.Scope)(interface_1.ScopeEnum.Singleton)(target);
    };
}
exports.Guard = Guard;
//# sourceMappingURL=guard.js.map