"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = exports.Scope = void 0;
const constant_1 = require("../constant");
const interface_1 = require("../../interface");
const metadataManager_1 = require("../metadataManager");
const provide_1 = require("./provide");
function Scope(scope, scopeOptions) {
    return function (target) {
        metadataManager_1.MetadataManager.defineMetadata(constant_1.SCOPE_KEY, { scope, ...scopeOptions }, target);
    };
}
exports.Scope = Scope;
function Singleton() {
    return function (target) {
        Scope(interface_1.ScopeEnum.Singleton)(target);
        (0, provide_1.Provide)()(target);
    };
}
exports.Singleton = Singleton;
//# sourceMappingURL=scope.js.map