import { ClassType, MethodDecoratorOptions, ObjectIdentifier, ParamDecoratorOptions, PropertyDecoratorOptions } from '../interface';
/**
 * This class is used to manage the decorator data of the class
 *
 * @since 3.0.0
 */
export declare class DecoratorManager {
    private static moduleStore;
    static saveModule(key: ObjectIdentifier, module: any): void;
    static listModule(key: ObjectIdentifier, filter?: (module: any) => boolean): any[];
    static savePreStartModule(module: any): void;
    static listPreStartModule(): any[];
    static resetModule(key: any): void;
    static clearAllModule(): void;
    static saveProviderId(identifier: ObjectIdentifier, target: ClassType): ClassType;
    static getProviderId(module: ClassType): string;
    static getProviderName(module: ClassType): string;
    static getProviderUUId(module: ClassType): string;
    static isProvide(target: any): boolean;
    static createCustomPropertyDecorator(decoratorKey: string, metadata: any, implOrOptions?: boolean | PropertyDecoratorOptions): PropertyDecorator;
    static createCustomMethodDecorator(decoratorKey: string, metadata: any, implOrOptions?: boolean | MethodDecoratorOptions): MethodDecorator;
    static createCustomParamDecorator(decoratorKey: string, metadata: any, implOrOptions?: boolean | ParamDecoratorOptions): ParameterDecorator;
}
//# sourceMappingURL=decoratorManager.d.ts.map