"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessTrigger = exports.ServerlessFunction = void 0;
const __1 = require("../");
const interface_1 = require("../../interface");
const metadataManager_1 = require("../metadataManager");
function ServerlessFunction(options) {
    return (target, key, descriptor) => {
        metadataManager_1.MetadataManager.defineMetadata(__1.SERVERLESS_FUNC_KEY, options, target, key);
    };
}
exports.ServerlessFunction = ServerlessFunction;
function ServerlessTrigger(type, metadata = {}) {
    return (target, functionName, descriptor) => {
        if (type === interface_1.ServerlessTriggerType.HTTP ||
            type === interface_1.ServerlessTriggerType.API_GATEWAY) {
            metadata['method'] = metadata['method'] ?? 'get';
        }
        __1.DecoratorManager.saveModule(__1.FUNC_KEY, target.constructor);
        // new method decorator
        metadata = metadata || {};
        metadataManager_1.MetadataManager.attachMetadata(__1.FUNC_KEY, {
            type,
            methodName: functionName,
            metadata,
        }, target);
    };
}
exports.ServerlessTrigger = ServerlessTrigger;
//# sourceMappingURL=serverlessTrigger.js.map