"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Task = void 0;
const constant_1 = require("../constant");
const decoratorManager_1 = require("../decoratorManager");
const metadataManager_1 = require("../metadataManager");
function Task(options) {
    return function (target, propertyKey, descriptor) {
        decoratorManager_1.DecoratorManager.saveModule(constant_1.MODULE_TASK_KEY, target.constructor);
        metadataManager_1.MetadataManager.attachMetadata(constant_1.MODULE_TASK_METADATA, {
            options,
            propertyKey,
            value: descriptor.value,
            name: target.constructor.name,
        }, target);
    };
}
exports.Task = Task;
//# sourceMappingURL=task.js.map