import { ILifeCycle, IMidwayApplication, IMidwayContainer, ObjectBeforeCreatedOptions, ObjectBeforeDestroyOptions, ObjectCreatedOptions, ObjectInitOptions, FunctionalConfigurationOptions } from '../interface';
export declare class FunctionalConfiguration implements ILifeCycle {
    protected options: FunctionalConfigurationOptions;
    constructor(options: FunctionalConfigurationOptions);
    onConfigLoad(container: IMidwayContainer, mainApp: IMidwayApplication): Promise<any>;
    onReady(container: IMidwayContainer, mainApp: IMidwayApplication): Promise<void>;
    onServerReady(container: IMidwayContainer, mainApp: IMidwayApplication): Promise<void>;
    onHealthCheck(container: IMidwayContainer): Promise<import("../interface").HealthResult>;
    onStop(container: IMidwayContainer, mainApp: IMidwayApplication): Promise<void>;
    onBeforeObjectCreated(Clzz: any, options: ObjectBeforeCreatedOptions): void;
    onObjectCreated<T>(ins: T, options: ObjectCreatedOptions<T>): void;
    onObjectInit<T>(ins: T, options: ObjectInitOptions): void;
    onBeforeObjectDestroy<T>(ins: T, options: ObjectBeforeDestroyOptions): void;
}
export declare const defineConfiguration: (options: FunctionalConfigurationOptions) => FunctionalConfiguration;
//# sourceMappingURL=configuration.d.ts.map