import { MethodDecoratorOptions, ObjectDefinitionOptions, ObjectIdentifier, ParamDecoratorOptions, TagPropsMetadata } from '../interface';
/**
 * save data to class
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param mergeIfExist
 * @since 2.3.0
 * @deprecated Use MetadataManager.defineMetadata instead
 */
export declare function saveClassMetadata(decoratorNameKey: ObjectIdentifier, data: any, target: any, mergeIfExist?: boolean): void;
/**
 * attach data to class
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param groupBy
 * @since 2.3.0
 * @deprecated Use MetadataManager.attachMetadata instead
 */
export declare function attachClassMetadata(decoratorNameKey: ObjectIdentifier, data: any, target: any, groupBy?: string): void;
/**
 * get data from class and proto
 * @param decoratorNameKey
 * @param target
 * @param propertyName
 * @param useCache
 * @since 2.3.0
 * @deprecated Use MetadataManager.getMetadata instead
 */
export declare function getClassExtendedMetadata<T = any>(decoratorNameKey: ObjectIdentifier, target: any, propertyName?: string, useCache?: boolean): T;
/**
 * get data from class
 * @param decoratorNameKey
 * @param target
 * @since 2.3.0
 * @deprecated Use MetadataManager.getOwnMetadata instead
 */
export declare function getClassMetadata<T = any>(decoratorNameKey: ObjectIdentifier, target: any): T;
/**
 * save property data to class
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated Use MetadataManager.defineMetadata instead
 */
export declare function savePropertyDataToClass(decoratorNameKey: ObjectIdentifier, data: any, target: any, propertyName: any): void;
/**
 * attach property data to class
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated
 */
export declare function attachPropertyDataToClass(decoratorNameKey: ObjectIdentifier, data: any, target: any, propertyName: any): void;
/**
 * get property data from class
 * @param decoratorNameKey
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated Use MetadataManager.getOwnMetadata instead
 */
export declare function getPropertyDataFromClass<T = any>(decoratorNameKey: ObjectIdentifier, target: any, propertyName: any): T;
/**
 * list property data from class
 * @param decoratorNameKey
 * @param target
 * @since 2.3.0
 * @deprecated
 */
export declare function listPropertyDataFromClass(decoratorNameKey: ObjectIdentifier, target: any): any[];
/**
 * save property data
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated Use MetadataManager.defineMetadata instead
 */
export declare function savePropertyMetadata(decoratorNameKey: ObjectIdentifier, data: any, target: any, propertyName: any): void;
/**
 * attach property data
 * @param decoratorNameKey
 * @param data
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated
 */
export declare function attachPropertyMetadata(decoratorNameKey: ObjectIdentifier, data: any, target: any, propertyName: any): void;
/**
 * get property data
 * @param decoratorNameKey
 * @param target
 * @param propertyName
 * @since 2.3.0
 * @deprecated Use MetadataManager.getOwnMetadata instead
 */
export declare function getPropertyMetadata<T = any>(decoratorNameKey: ObjectIdentifier, target: any, propertyName: any): T;
/**
 * save preload module by target
 * @param target
 * @since 2.0.0
 * @deprecated Use DecoratorManager.savePreStartModule instead
 */
export declare function savePreloadModule(target: any): void;
/**
 * list preload module
 * @since 2.0.0
 * @deprecated Use DecoratorManager.listPreStartModule instead
 */
export declare function listPreloadModule(): any[];
/**
 * save module to inner map
 * @param decoratorNameKey
 * @param target
 * @since 2.0.0
 * @deprecated Use DecoratorManager.saveModule instead
 */
export declare function saveModule(decoratorNameKey: ObjectIdentifier, target: any): void;
/**
 * list module from decorator key
 * @param decoratorNameKey
 * @param filter
 * @since 2.0.0
 * @deprecated Use DecoratorManager.listModule instead
 */
export declare function listModule(decoratorNameKey: ObjectIdentifier, filter?: (module: any) => boolean): any[];
/**
 * reset module
 * @param decoratorNameKey
 * @since 2.0.0
 * @deprecated Use DecoratorManager.resetModule instead
 */
export declare function resetModule(decoratorNameKey: ObjectIdentifier): void;
/**
 * clear all module
 * @since 3.0.0
 * @deprecated Use DecoratorManager.clearAllModule instead
 */
export declare function clearAllModule(): void;
/**
 * class provider id
 * @since 2.3.0
 * @deprecated Use DecoratorManager.saveProviderId instead
 */
export declare function saveProviderId(identifier: ObjectIdentifier, target: any): import("../interface").ClassType;
/**
 * get provider id from module
 * @since 3.0.0
 * @deprecated Use DecoratorManager.getProviderId instead
 */
export declare function getProviderId(module: any): string;
/**
 * @since 3.0.0
 * @deprecated Use DecoratorManager.getProviderName instead
 */
export declare function getProviderName(module: any): string;
/**
 * get provider uuid from module
 * @since 3.0.0
 * @deprecated Use DecoratorManager.getProviderUUId instead
 */
export declare function getProviderUUId(module: any): string;
/**
 * use @Provide decorator or not
 * @since 3.0.0
 * @deprecated Use DecoratorManager.isProvide instead
 */
export declare function isProvide(target: any): boolean;
/**
 * Create a custom property inject
 * @param decoratorKey
 * @param metadata
 * @param impl default true, configuration need decoratorService.registerMethodHandler
 * @since 3.0.0
 * @deprecated Use DecoratorManager.createCustomPropertyDecorator instead
 */
export declare function createCustomPropertyDecorator(decoratorKey: string, metadata: any, impl?: boolean): PropertyDecorator;
/**
 * Create a custom method decorator
 * @param decoratorKey
 * @param metadata
 * @param implOrOptions
 * @since 3.0.0
 * @deprecated Use DecoratorManager.createCustomMethodDecorator instead
 */
export declare function createCustomMethodDecorator(decoratorKey: string, metadata: any, implOrOptions?: boolean | MethodDecoratorOptions): MethodDecorator;
/**
 * Create a custom param decorator
 * @param decoratorKey
 * @param metadata
 * @param implOrOptions
 * @since 3.0.0
 * @deprecated Use DecoratorManager.createCustomParamDecorator instead
 */
export declare function createCustomParamDecorator(decoratorKey: string, metadata: any, implOrOptions?: boolean | ParamDecoratorOptions): ParameterDecorator;
/**
 * get property(method) type from metadata
 * @param target
 * @param methodName
 * @since 3.0.0
 * @deprecated Use MetadataManager.getPropertyType instead
 */
export declare function getPropertyType(target: any, methodName: string | symbol): import("../interface").TSDesignType<unknown>;
/**
 * get parameters type by reflect-metadata
 * @since 3.0.0
 * @deprecated Use MetadataManager.getMethodParamTypes instead
 */
export declare function getMethodParamTypes(target: any, methodName: string | symbol): any;
/**
 * save property inject args
 * @param opts 参数
 * @since 2.3.0
 * @deprecated Use MetadataManager.attachMetadata instead
 */
export declare function savePropertyInject(opts: {
    identifier: ObjectIdentifier;
    target: any;
    targetKey: string;
    args?: any;
}): void;
/**
 * get property inject args
 * @param target
 * @param useCache
 * @since 2.3.0
 * @deprecated Use MetadataManager.getMetadata instead
 */
export declare function getPropertyInject(target: any, useCache?: boolean): {
    [methodName: string]: TagPropsMetadata;
};
/**
 * save class object definition
 * @param target class
 * @param props property data
 * @since 2.3.0
 * @deprecated Use MetadataManager.attachMetadata instead
 */
export declare function saveObjectDefinition(target: any, props?: {}): any;
/**
 * get class object definition from metadata
 * @param target
 * @since 2.3.0
 * @deprecated Use MetadataManager.getPropertiesWithMetadata instead
 */
export declare function getObjectDefinition(target: any): ObjectDefinitionOptions;
//# sourceMappingURL=decorator.d.ts.map