/// <reference types="node" />
export declare function isPath(p: any): boolean;
export declare function isPathEqual(one: string, two: string): boolean;
export declare function getFileContentSync(filePath: any, encoding?: BufferEncoding): any;
/**
 * Normalize path, if p is absolute path, return p, otherwise join p with baseDir
 *
 * @example
 * ```ts
 * normalizePath('/a/b', 'c') => '/a/b/c'
 * normalizePath('/a/b', '/c') => '/c'
 * ```
 *
 * @param baseDir
 * @param p
 */
export declare function normalizePath(baseDir: any, p: any): any;
export declare function getModuleRequirePathList(moduleName: string): string[];
export declare const PathFileUtil: {
    isPath: typeof isPath;
    isPathEqual: typeof isPathEqual;
    getFileContentSync: typeof getFileContentSync;
};
//# sourceMappingURL=pathFileUtil.d.ts.map